// Accord.h: interface for the CAccord class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACCORD_H__71CB57B9_51D3_4A4A_8B02_801FEA969C6C__INCLUDED_)
#define AFX_ACCORD_H__71CB57B9_51D3_4A4A_8B02_801FEA969C6C__INCLUDED_

#include <iostream>
#include <vector>

class CAccord
{
public:
    bool CalculNotes(void);	//Mise à jour de la fréquence des notes en fonction du nom des notes
	int GetNoteSup(double Freq);	//Retourne l'index de la note de l'accord immédiatement supérieure
	int GetNoteInf(double Freq);	//Retourne l'index de la note de l'accord immédiatement inférieure
	std::string GetNomNote(int Index);	//Retourne le nom de la note en fonction de sa position
	void SetNomNote(unsigned int Index, std::string Note);  //Met à jour le nom de la note suivant l'index donné
	std::string GetNomAccord(void);	//Retourne le nom de l'accord
	void SetAccord(std::string NomAccord);	//Met à jour le nom de l'accord, le string des notes, la fréquence des notes
	double GetValeurNote(int Index);	//Retourne la fréquence de la note en fonction de sa position
	CAccord(std::string NomAccord);	//Même chose que SetNomAccord mais en constructeur
	CAccord();	//Constructeur par défaut
	virtual ~CAccord();	//Destructeur

private:
	void Initialisation();	//Initialisation des variables
	std::vector<std::string> m_szarNotes;	//Nom de toutes les notes
	static const double m_fNoteEtalon[18];	//Valeur de toutes les notes de la portée
	double m_fNotes[6];	//Valeur des 6 notes de l'accord
	std::string m_szNomAccord;	//Valeur de l'accord
	std::vector<std::string> MapIndexNote;	//Nom de toutes les notes de la portée
};

#endif // !defined(AFX_ACCORD_H__71CB57B9_51D3_4A4A_8B02_801FEA969C6C__INCLUDED_)
