#include <libglademm.h>
#include "Proprietes.h"
#include <libintl.h>
#define _(String) gettext (String)
#ifdef _WIN32
#include <windows.h>
#include <mmsystem.h>
#endif //_WIN32

//Constructeur
Gtk_Proprietes::Gtk_Proprietes(BaseObjectType *cobject, const Glib::RefPtr<Gnome::Glade::Xml> & refGlade):Gtk::Dialog(cobject),
 m_refGlade(refGlade)
{
    m_refGlade->get_widget("combobox3",m_cboAccord);    //des deux combos
    m_refGlade->get_widget("combobox1",m_cboCarteSon);   //puis le reste des controles
    m_refGlade->get_widget("spinbutton4",m_ctlSpin_Echantillon);
    m_refGlade->get_widget("spinbutton5",m_ctlSpin_FreqEchantillonage);
    m_refGlade->get_widget("button1",m_btnValider);
    m_refGlade->get_widget("button2",m_btnAnnuler);
    m_refGlade->get_widget("checkbutton2",m_ctl_CheckFrequence);
    m_refGlade->get_widget("spinbutton3",m_ctlSpin_Attenuation);
    m_refGlade->get_widget("combobox4",m_cboGraphique);
    m_refGlade->get_widget("image1",m_imgFenetre);
    m_refGlade->get_widget("checkbutton1",m_ctl_CheckRepere);

    if (m_cboGraphique)
    {
	 m_cboGraphique->signal_changed().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_cboGraphique_changed));
    }

    if (m_cboCarteSon)  //Création du signal du changement du combo et création de la liste
    {
        m_cboCarteSon->signal_changed().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_cboCarteSon_changed));
        m_refTreeModel_CarteSon = Gtk::ListStore::create(m_Columns_carte_son);
        m_cboCarteSon->set_model(m_refTreeModel_CarteSon);
    }
    if (m_ctlSpin_Echantillon)  //Connection pour le changement de la valeur des échantillons
    {
        nPowerEchantillons=m_ctlSpin_Echantillon->get_value();
        m_ctlSpin_Echantillon->signal_value_changed().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_EchantillonChange));
        m_ctlSpin_Echantillon->signal_changed().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_EchantillonChange));

    }
    #ifdef _WIN32
    if (m_ctlSpin_FreqEchantillonage)
    {
        nFrequenceEchantillonnage=m_ctlSpin_FreqEchantillonage->get_value();
        m_ctlSpin_FreqEchantillonage->signal_value_changed().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_EchantillonnageChange));
        m_ctlSpin_FreqEchantillonage->signal_changed().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_EchantillonnageChange));

    }

    #endif
    if (m_cboAccord)    //Si le pointeur existe
    {
        m_refTreeModel_Accord = Gtk::ListStore::create(m_Columns_accord);   //Création de la liste
        m_cboAccord->set_model(m_refTreeModel_Accord);  //Mise à jour du combo avec cette liste
    }
    if (m_btnValider)   //Création du signal pour le bouton valider
    {
       m_btnValider->signal_clicked().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_Valider));
    }
    if (m_btnAnnuler)   //Pour le bouton annuler
    {
       m_btnAnnuler->signal_clicked().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_Annuler));
    }
    if (m_ctl_CheckFrequence)
    {
	 m_ctl_CheckFrequence->signal_clicked().connect(sigc::mem_fun(*this,&Gtk_Proprietes::on_chkFrequence));
    }
#ifdef _WIN32
    set_size_request(500,300);
#endif
}
//Destructeur
Gtk_Proprietes::~Gtk_Proprietes()
{

}
//Lors du changement de l'interface graphique
void Gtk_Proprietes:: on_cboGraphique_changed()
{
     std::string image;

     switch (m_cboGraphique->get_active_row_number())
     {
     case 0:
#ifdef __linux__
	  image=szChemin_share+"/Affichage_Normal.png";
#elif defined _WIN32
	  image=szChemin_share+"\\Affichage_Normal.png";
#endif
	  break;
     case 1:
#ifdef __linux__
	  image=szChemin_share+"/Affichage_rond.png";
#elif defined _WIN32
	  image=szChemin_share+"\\Affichage_rond.png";
#endif
	  break;
     }
     m_imgFenetre->set(image);
}
//Lors du changement d'item dans le combo carte son
void Gtk_Proprietes::on_cboCarteSon_changed(void)
{
     int IndexCarte; //L'index de la carte dans le combo
    //On retrouve le nom
    Gtk::TreeModel::iterator iter=m_cboCarteSon->get_active();

    if (iter)
    {
        Gtk::TreeModel::Row row=*iter;

#ifdef __linux__
	char *nom_carte;    //Nom de la carte
	int numero_carte;   //Numéro de la carte
	int err;    //Retour pour une erreur

	unsigned int rate_min, rate_max;  // Fréquence d'échantillonnage
        //l'index de la carte
        IndexCarte=row[m_Columns_accord.m_col_id];
        snd_card_get_name(IndexCarte,&nom_carte);
        strcat(nom_carte,"\n");

        //chargement des caractéristique de la carte son
        if ((err=snd_card_load(IndexCarte))!=1)
        {

	     std::string message(_("Problem to load the sound card driver\n"));


            message+=nom_carte;

            message+=snd_strerror(err);
            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title(_("Sound card problem"));
            Dialog.run();
        }
        else
        {
	     char *devname=NULL; //Nom de la carte pour le système

	     snd_pcm_hw_params_t *hw_params; //Handle pour le hardware
	     snd_pcm_t *handle;  //Handle de la carte son
            numero_carte=arsndCartes.at(IndexCarte);

            devname=(char*)malloc(100);

            if (devname==NULL)
            {
		 std::string message(_("Memory allocation problem"));

                Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                Dialog.set_title(message);
                Dialog.run();

            }
            else
            {

                snprintf(devname,100, ALSA_HARDWARE_CARD, numero_carte);

                //Ouverture de la carte
                if ((err = snd_pcm_open (&handle, devname, SND_PCM_STREAM_CAPTURE, SND_PCM_ASYNC)) < 0)
                {
		     std::string message(_("Problem to open the sound card\n"));
                    message+=nom_carte;

                    message+=snd_strerror(err);
                    Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                    Dialog.set_title(_("Sound card problem"));
                    Dialog.run();

                }
                else
                {
                    //Allocation mémoire pour récupérer les paramètres de la carte
                    if ((err = snd_pcm_hw_params_malloc (&hw_params)) < 0)
                    {
			 std::string message(_("Problem to allocate the hardware sound card parameters\n"));


                        message+=nom_carte;

                        message+=snd_strerror(err);
                        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                        Dialog.set_title(_("Sound card memory problem"));
                        Dialog.run();
                    }
                    else
                    {
                        //Récupération des paramètres de la carte
                        if ((err = snd_pcm_hw_params_any (handle, hw_params)) < 0)
                        {
			     std::string message(_("Problem to initialise the hardware sound card parameters\n"));
                            message+=nom_carte;

                            message+=snd_strerror(err);
                            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                            Dialog.set_title(_("Sound card initialisation problem"));
                            Dialog.run();

                        }
                        else
                        {

                            //Carte dans la configuration INTERLEAVED
                            if ((err = snd_pcm_hw_params_set_access (handle, hw_params, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0)
                            {
				 std::string message(_("Problem to update the sound card access mode\n"));
                                message+=nom_carte;

                                message+=snd_strerror(err);
                                Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                                Dialog.set_title(_("Sound card update problem"));
                                Dialog.run();

                            }
                            else
                            {
                                //Son de la carte au format 16 Bits
                                if ((err = snd_pcm_hw_params_set_format (handle, hw_params, SND_PCM_FORMAT_S16_LE)) < 0)
                                {
				     std::string message(_("Problem to set sample sound card format\n"));
                                    message+=nom_carte;

                                    message+=snd_strerror(err);
                                    Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                                    Dialog.set_title(_("Sound card format problem"));
                                    Dialog.run();

                                }
                                else
                                {
                                    Gtk::Adjustment *range;

                                    //Récupération des paramètres rate min et max
                                    snd_pcm_hw_params_get_rate_min(hw_params,&rate_min,0);

                                    snd_pcm_hw_params_get_rate_max(hw_params,&rate_max,0);

                                    //Récupération d'un pointeur Adjustement
                                    range=m_ctlSpin_FreqEchantillonage->get_adjustment();

                                    if (range)
                                    {
                                        //Incrément du Spin à rate min de la carte
                                        range->set_step_increment(rate_min);
                                        // Valeur la plus basse à rate min
                                        range->set_lower(rate_min);
                                        //Valeur la plus haute à rate max
                                        range->set_upper(rate_max);
                                        //Valeur actuelle à moitié des deux valeurs
                                        range->set_value(rate_max/2);
                                        //Mise à jour du SPIN
                                        m_ctlSpin_FreqEchantillonage->set_adjustment(*range);
                                    }
                                }
                            }
                        }
                    }
                    snd_pcm_hw_free(handle);    //Libération de la mémoire

                    snd_pcm_close(handle);  //Fermeture de la carte son
                }
                free(devname);  //Libération de la ressource
            }

        }
#elif defined (_WIN32)
WAVEINCAPS caracteristiques;	//Variable pour les caractéristiques de la carte son
unsigned int resultat;

IndexCarte=row[m_Columns_accord.m_col_id];

resultat=waveInGetDevCaps(IndexCarte,&caracteristiques,sizeof(WAVEINCAPS)); //On récupère les caractéristiques de la carte son
//Si pa d'erreur
if (resultat==MMSYSERR_NOERROR)
{

     unsigned long support;
     Gtk::Adjustment *range;

//Mise à jour des fréquences d'échantillonage en fonction des capacités de la carte

     range=m_ctlSpin_FreqEchantillonage->get_adjustment();

     range->set_lower(0);
     range->set_upper(0);

     support=caracteristiques.dwFormats & WAVE_FORMAT_4M16;

     if (support)
     {
          range->set_lower(11025);
          range->set_upper(44100);
     }
     else
     {

	  support=caracteristiques.dwFormats & WAVE_FORMAT_2M16;

	  if (support)
	  {
	       range->set_upper(22050);
	       range->set_lower(11025);

	  }
	  else
	  {

	       support=caracteristiques.dwFormats & WAVE_FORMAT_1M16;

	       if (support)
	       {
		    range->set_upper(11025);

		    range->set_lower(11025);
	       }
	       else
	       {
		    std::string message(_("The sample frequency is unknown"));

		    Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
		    Dialog.set_title(_("Sound card sample frequency problem"));
		    Dialog.run();
	       }
	  }
     }

     range->set_value(range->get_upper());

     m_ctlSpin_FreqEchantillonage->set_adjustment(*range);

}
else
{
     std::string message(_("The sound card access is impossible"));

     Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
     Dialog.set_title(_("Sound card access problem"));
     Dialog.run();
}


#endif

    }

}

#ifdef __linux__
//Chargement des cartes sons disponibles pour Linux

int Gtk_Proprietes::Chargement_Liste_Carte_Son_Linux(void)
{
     int ret=-1, sndCarte,IndexCarte=0;
     char *nom_carte;

     sndCarte=-1;

     //La première
     snd_card_next(&sndCarte);

    //tant qu'il y en a
    while (sndCarte!=-1)
    {

        //on essaye la communication
        if (snd_card_load(sndCarte)==1)
        {
            ret=0;
            IndexCarte++;

            arsndCartes.push_back(sndCarte);

            snd_card_get_name(sndCarte,&nom_carte);

            //Mise à jour du combo carte son
            Gtk::TreeModel::Row row = *(m_refTreeModel_CarteSon->append());

            row[m_Columns_carte_son.m_col_id]=IndexCarte-1;

            row[m_Columns_carte_son.m_col_name]=nom_carte;


        }
        else
        {
	    std::string message(_("Problem to load the sound card driver\n"));

            snd_card_get_name(sndCarte,&nom_carte);
            message+=nom_carte;
            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title(_("Sound card problem"));
            Dialog.run();
        }
        //A la prochaine
        snd_card_next(&sndCarte);
    }

    return ret;
}

#endif  //Linux

#ifdef _WIN32
//Chargement des cartes sons disponibles pour Windaube
int Gtk_Proprietes::Chargement_Liste_Carte_Son_W$(void)
{
     int ret,sndCarte;
     unsigned int nbrecarte=0;

    sndCarte=waveInGetNumDevs(); //On récupère le nombre de carte son

    for (int i=0;i<sndCarte;i++) //Pour chaque carte son
    {
	WAVEINCAPS caracteristiques;	//Variable pour les caractéristiques de la carte son
	unsigned int resultat;


	resultat=waveInGetDevCaps(i,&caracteristiques,sizeof(WAVEINCAPS));	//On récupère les caractéristiques de la carte son

	if (resultat==MMSYSERR_NOERROR)
	{

	     //Mise à jour du combo carte son
            Gtk::TreeModel::Row row = *(m_refTreeModel_CarteSon->append());

	     row[m_Columns_carte_son.m_col_id]=nbrecarte;

	     row[m_Columns_carte_son.m_col_name]=caracteristiques.szPname;
	     nbrecarte++;
	}
	else
	{
	    std::string message(_("Problem to load the sound card driver\n"));
            message+=caracteristiques.szPname;
            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title("Sound card problem");
            Dialog.run();
	}

    }

    if (nbrecarte==0)
	 ret=-1;
    else
	 ret=0;


     return ret;

}

#endif  //WIN32

//Chargement de toutes les cartes son
int Gtk_Proprietes::Chargement_Liste_Carte_Son(void)
{
     int ret;

#ifdef __linux__

     ret=Chargement_Liste_Carte_Son_Linux();


#elif defined (_WIN32)

     ret=Chargement_Liste_Carte_Son_W$();


#endif


    //Pas de carte son
    if (ret==-1)
    {
	 std::string message(_("No sound card\n"));
	 message+=_("The software stopped");
        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
        Dialog.set_title(_("Sound card detection problem"));
        Dialog.run();
        ret=-1;

    }
    else
    {
        //Chargement de la première
        m_cboCarteSon->pack_start(m_Columns_carte_son.m_col_name);

    }
    return ret;

}

//Chargement des accords du fichier
int Gtk_Proprietes::Chargement_Accords(std::string fichier_xml)
{
    int ret,IndexLigne=1;

    CAccord Notes_Accords;  //Variables contenant les accords
    char *nomAccord;    //Nom de l'accord
    xmlDocPtr xmlparametres_doc = NULL; //Pointeur sur le document
    xmlXPathContextPtr xmlparametres_context = NULL;    //Pointeur sur le contexe du fichier xml
    //Pointeur sur les objets du fichier xml
    xmlXPathObjectPtr xmlobject_accord,xmlobject_note,xmlobject_nomAccord, xmlobject_nomNote;
    xmlNodePtr node;    //Noeud à récupérer

    ret=-1;
    //On retrouve le pointeur du document
    xmlparametres_doc = xmlParseFile (fichier_xml.c_str());

    if (xmlparametres_doc)
    {
        //Initialisation des chemins
        xmlXPathInit ();

        // Récupération du contexte
        xmlparametres_context = xmlXPathNewContext (xmlparametres_doc);

        if (xmlparametres_context)
        {
            //Récupération de tous les objets /accords
            xmlobject_accord = xmlXPathEval (BAD_CAST "/accords/text()", xmlparametres_context);

            //Pour tous les accords
            for (int IndexAccord=1;IndexAccord<xmlobject_accord->nodesetval->nodeNr;IndexAccord++)
            {

                std::string path_note("/accords/accord");
                std::string path_nom_accord,path_temp;
                std::ostringstream Nombre;


                Nombre<<IndexAccord;

                path_note+=Nombre.str();

                path_temp=path_note;
                //Mise à jour des chemins
                path_nom_accord=path_note + "/nom/text()";

                path_note+="/text()";

                //Récupération des objets des notes de l'accord
                xmlobject_note = xmlXPathEval ((const xmlChar*)path_note.c_str(), xmlparametres_context);

                xmlobject_nomAccord = xmlXPathEval ((const xmlChar*)path_nom_accord.c_str(), xmlparametres_context);

                node=xmlobject_nomAccord->nodesetval->nodeTab[0];

                //Récupération du nom de l'accord
                nomAccord=(char*)node->content;

                //Mise à jour de l'objet CAccord
                Notes_Accords.SetAccord(nomAccord);

                //Pour toutes les notes contenues dans l'accord
                for (int IndexNote=1; IndexNote<xmlobject_note->nodesetval->nodeNr-1;IndexNote++)
                {
                    std::string path_nom_note(path_temp);
                    std::ostringstream stream_o;

                    path_nom_note+="/note";

                    stream_o<<IndexNote;    //fréquence d'échantillonnage

                    path_nom_note+=stream_o.str();

                    //Mise à jour du chemin d'une note
                    path_nom_note+="/text()";

                    //Récupération de l'objet du nom de la note
                    xmlobject_nomNote = xmlXPathEval ((const xmlChar*)path_nom_note.c_str(), xmlparametres_context);

                    if (xmlobject_nomNote->nodesetval->nodeNr)
                    {
                        //Récupération du noeud de la note
                        node=xmlobject_nomNote->nodesetval->nodeTab[0];

                        //Mise à jour de l'objet CAccord
                        Notes_Accords.SetNomNote(IndexNote-1, (const char*)node->content);
                    }

                }

                //Si l'accord est correct
                 if  (Notes_Accords.CalculNotes()==false)
                   {
                        std::string message;
                        std::ostringstream out;

                        out<<IndexAccord;

                        message= _("The chord number ");
                        message+=out.str();
                        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_WARNING ,Gtk::BUTTONS_OK ,false );
                        Dialog.set_title(_("Chord format problem"));
                        Dialog.run();


                   }
                   else
                   {
                       //Sauvegarde de l'accord et maj du combo du nom des accords

                        Gtk::TreeModel::Row row = *(m_refTreeModel_Accord->append());

                        row[m_Columns_accord.m_col_id]=IndexLigne;
                        row[m_Columns_accord.m_col_name]=Notes_Accords.GetNomAccord();

                        IndexLigne++;

                        ret=1;
                   }


            }
            //Libération des ressources
            xmlXPathFreeObject(xmlobject_accord);
            xmlXPathFreeObject(xmlobject_note);
            xmlXPathFreeObject(xmlobject_nomAccord);
            xmlXPathFreeObject(xmlobject_nomNote);
            xmlXPathFreeContext(xmlparametres_context);


        }
        else
        {
	     std::string message(_("Problem to create a xml context"));
            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title(_("XML Problem"));
            Dialog.run();

            ret=-1;
        }

         xmlFreeDoc(xmlparametres_doc);
         m_cboAccord->pack_start(m_Columns_accord.m_col_name);

    }
    //Choix du fichier dans une boite de dialogue
    else
    {
        Glib::ustring nomfichier;

        std::string message(_("Problem to open the chords file\n"));
        message+=fichier_xml;
        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
        Dialog.set_title(_("Problem chords file"));
        Dialog.run();

        //Fenetre pour choisir le fichier
        Gtk::FileChooserDialog ChoixFichier(_("Choose the file"),Gtk::FILE_CHOOSER_ACTION_OPEN);
        ChoixFichier.set_transient_for(*this);

        //Ajout de boutons à la fenetre
        ChoixFichier.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
        ChoixFichier.add_button(Gtk::Stock::OPEN, Gtk::RESPONSE_OK);

        Gtk::FileFilter filtre;
        filtre.set_name(_("XML files"));
        filtre.add_pattern("*.xml");

        ChoixFichier.add_filter(filtre);

        int result=ChoixFichier.run();

        if (result==Gtk::RESPONSE_OK)
        {
            ret=Chargement_Accords(ChoixFichier.get_filename());
        }
        else
            ret=-1;
    }

    return ret;
}

//Changement du nombre d'échantillons
void Gtk_Proprietes::on_EchantillonChange()
{
    Gtk::Adjustment *range;

    range=m_ctlSpin_Echantillon->get_adjustment();

    if (range)
    {
        //Si on diminue le nombre d'échantillons
        if (nPowerEchantillons>range->get_value())
        {
            //La valeur est divisée par deux
            range->set_value(nPowerEchantillons/2);
            //Et l'incrément également
            range->set_step_increment(nPowerEchantillons/2);

        }
        else if (nPowerEchantillons<range->get_value())
        {
            //Sinon l'incrément est la nouvelle valeur
            range->set_step_increment(range->get_value());
        }

        //On sauvegarde la valeur du nombre d'échantillons
        nPowerEchantillons=range->get_value();
        m_ctlSpin_Echantillon->set_adjustment(*range);

    }


}
//Validation des paramètres
void Gtk_Proprietes::on_Valider(void)
{

//Création du fichier meme s'il existe
    std::ofstream fichier_xml(szChemin_param_xml.c_str(), std::ios::out | std::ios::trunc);
    std::string message(_("Cannot write the element ")); 
    std::string titre(_("Writing problem"));

    if (fichier_xml)
    {
        int reponse;
        xmlTextWriterPtr writer;    //Pointeur sur le fichier

        fichier_xml.close();    //Fermeture du fichier

        //Récupération des paramètres
        param_xml.nFreqEchantillonnage=m_ctlSpin_FreqEchantillonage->get_value();
        param_xml.nNumeroAccord=m_cboAccord->get_active_row_number();
        param_xml.nNumero_carte_son=m_cboCarteSon->get_active_row_number();
        param_xml.nNbreEchantillon=m_ctlSpin_Echantillon->get_value();
        param_xml.bVisuFreq=m_ctl_CheckFrequence->get_active();
	param_xml.bVisuRepere=m_ctl_CheckRepere->get_active();
        param_xml.nValeurAttenuation= m_ctlSpin_Attenuation->get_value();
	param_xml.nInterface_Affichage=m_cboGraphique->get_active_row_number();

        //Récupération du pointeur du fichier xml
        writer = xmlNewTextWriterFilename(szChemin_param_xml.c_str(), 0);

        if (writer)
        {
            //En tête du fichier
            reponse = xmlTextWriterStartDocument(writer, NULL, NULL, NULL);

            if (reponse!=-1)
            {
                //Création du noeud PARAMETRES
                reponse = xmlTextWriterStartElement(writer, BAD_CAST "PARAMETRES");

                if (reponse!=-1)
                {
                    //Création du noeud HEADER
                    reponse = xmlTextWriterStartElement(writer, BAD_CAST "HEADER");

                    if (reponse!=-1)
                    {
                        //Création du noeud Visualisation_Spectrale et de sa valeur associée
                        reponse = xmlTextWriterWriteFormatElement(writer, BAD_CAST "Visualisation_Spectrale","%d", param_xml.bVisuFreq);

                        if (reponse!=-1)
                        {
                            //meme chose pour les autres paramètres
                            reponse = xmlTextWriterWriteFormatElement(writer, BAD_CAST "Frequence_Echantillonnage","%d", param_xml.nFreqEchantillonnage);

                            if (reponse!=-1)
                            {
                               reponse = xmlTextWriterWriteFormatElement(writer, BAD_CAST "Nombre_Echantillon","%d", param_xml.nNbreEchantillon);

                               if (reponse!=-1)
                               {
                                   reponse=xmlTextWriterWriteFormatElement(writer, BAD_CAST "Numero_Accord","%d", param_xml.nNumeroAccord);

                                   if (reponse!=-1)
                                   {
                                        reponse=xmlTextWriterWriteFormatElement(writer, BAD_CAST "Numero_Carte_Son","%d", param_xml.nNumero_carte_son);

                                        if (reponse!=-1)
                                        {
                                            reponse=xmlTextWriterWriteFormatElement(writer, BAD_CAST "Valeur_Attenuation","%d", param_xml.nValeurAttenuation);


                                            if (reponse!=-1)
                                            {
						 reponse=xmlTextWriterWriteFormatElement(writer,BAD_CAST "Interface_Graphique","%d",param_xml.nInterface_Affichage);
						 if (reponse!=-1)
						 {
						    reponse=xmlTextWriterWriteFormatElement(writer,BAD_CAST "Frequence_Repere","%d",param_xml.bVisuRepere);
						      if (reponse!=-1)
						      {
							   reponse = xmlTextWriterEndElement(writer);

							   if (reponse!=-1)
							   {
								reponse = xmlTextWriterEndDocument(writer);

								if (reponse==-1)
								{
								     std::string message(_("Cannot close the document"));
								     Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
								     Dialog.set_title(titre);
								     Dialog.run();
								}

							   }
							   else
							   {
								std::string message(_("Cannot close the element "));
								message+="HEADER";
								Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
								Dialog.set_title(titre);
								Dialog.run();
							   }
						      }
						      else
						      {
							   
							   message+="Visualisation repère";
							   Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
							   Dialog.set_title(titre);
							   Dialog.run();
						      }
						 }
						 else
						 {	  
						       message+="interface graphique";
						      Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
						      Dialog.set_title(titre);
						      Dialog.run();
						 }

                                            }
                                            else
                                            {

                                               
						message+="Valeur_Attenuation";
                                                Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
						Dialog.set_title(titre);
                                                Dialog.run();
                                            }

                                        }
                                        else
                                        {
                                         
					    message+="Numero_Carte_Son";
                                            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
					    Dialog.set_title(titre);
                                            Dialog.run();
                                        }
                                   }
                                   else
                                   {
                                        
					message+="Numero_Accord";
                                        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                                        Dialog.set_title(titre);
                                        Dialog.run();
                                   }

                               }
                               else
                               {
                                    
				    message+="Nombre_Echantillon";
                                    Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                                    Dialog.set_title(titre);
                                    Dialog.run();
                               }

                            }
                            else
                            {

				 message+="Frequence_Echantillonnage";
                                Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                                Dialog.set_title(titre);
                                Dialog.run();
                            }

                        }
                        else
                        {
                            message+="Visualisation_Spectrale";
                            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                            Dialog.set_title(titre);
                            Dialog.run();

                        }
                    }
                    else
                    {
                        message+="HEADER";
                        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                        Dialog.set_title(titre);
                        Dialog.run();
                    }
                }
                else
                {
		     std::string message(_("Cannot write the first element"));
                    Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                    Dialog.set_title(titre);
                    Dialog.run();
                }

            }
            else
            {
		 std::string message(_("Cannot write to the xml document"));
                Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
                Dialog.set_title(titre);
                Dialog.run();
            }

             xmlFreeTextWriter(writer);

        }
        else
        {
	     std::string message(_("Cannot create the object "));
	     message+="WRITER";
            Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title(_("Create object problem"));
            Dialog.run();

        }

    }
    else
    {
	 std::string message(_("Cannot create the file"));
	 message+=" guitar_tuner.xml ";
        Gtk::MessageDialog Dialog(message.c_str(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
        Dialog.set_title(_("Create settings file problem"));
        Dialog.run();
    }

    hide(); //Fermeture de la boite de dialogue

}
//Lors de l'appui sur Annuler
void Gtk_Proprietes::on_Annuler(void)
{
    hide(); //Fermeture de la boite de dialogue
}

//Mise à jour des paramètres et des contrôles associés
void Gtk_Proprietes::SetParametres(parametres param)
{
    param_xml=param;

    m_ctlSpin_FreqEchantillonage->set_value(param_xml.nFreqEchantillonnage);
    m_cboAccord->set_active(param_xml.nNumeroAccord);
    m_cboCarteSon->set_active(param_xml.nNumero_carte_son);
    m_ctlSpin_Echantillon->set_value(param_xml.nNbreEchantillon);
    m_ctl_CheckFrequence->set_active(param_xml.bVisuFreq);
    on_chkFrequence();
    m_ctlSpin_Attenuation->set_value(param_xml.nValeurAttenuation);
    m_cboGraphique->set_active(param_xml.nInterface_Affichage);
    m_ctl_CheckRepere->set_active(param_xml.bVisuRepere);

}
//Mise à jour du nom du chemin du fichier parametres
void Gtk_Proprietes::SetCheminParam_XML(std::string Chemin)
{

    szChemin_param_xml=Chemin;
}
//Mise à jour du chemin du dossier Share
void Gtk_Proprietes::SetCheminShare(std::string Chemin )
{
     szChemin_share=Chemin;
}
#ifdef _WIN32
//Lors du changement de la fréquence d'échantillonnage de la carte son
void Gtk_Proprietes::on_EchantillonnageChange()
{
    Gtk::Adjustment *range;

    range=m_ctlSpin_FreqEchantillonage->get_adjustment();

    if (range)
    {
        //Si on diminue le nombre d'échantillons
        if (nFrequenceEchantillonnage>range->get_value())
        {
            //La valeur est divisée par deux
            range->set_value(nFrequenceEchantillonnage/2);
            //Et l'incrément également
            range->set_step_increment(nFrequenceEchantillonnage/2);

        }
        else if (nFrequenceEchantillonnage<range->get_value())
        {
            //Sinon l'incrément est la nouvelle valeur
            range->set_step_increment(range->get_value());
        }

        //On sauvegarde la valeur du nombre d'échantillons
        nFrequenceEchantillonnage=range->get_value();
        m_ctlSpin_FreqEchantillonage->set_adjustment(*range);

    }
}
#endif
//Lors de l'appui sur le check de visualisation de la fenêtre spectrale
void Gtk_Proprietes::on_chkFrequence()
{
     if (m_ctl_CheckFrequence->get_active())
//Si la fenêtre est active la visualisation des traits des notes est disponibles
	  m_ctl_CheckRepere->set_sensitive(true);
     else
     {
//Sinon pas disponible et inhibé
	  m_ctl_CheckRepere->set_sensitive(false);
	  m_ctl_CheckRepere->set_active(false);
     }
}
