#ifndef PROPRIETES_H_INCLUDED
#define PROPRIETES_H_INCLUDED
#include <libglademm.h>
#include <gtkmm.h>
#include <libxml/xmlwriter.h>
#include <libxml/xpath.h>
#ifdef __linux__
#include <asoundlib.h>
#endif
#include <fstream>
#include "Variables.h"
#include "Accord.h"
//classe de la fenetre propriétés
class Gtk_Proprietes : public Gtk::Dialog
{
    public:
    Gtk_Proprietes(BaseObjectType *cobject, const Glib::RefPtr<Gnome::Glade::Xml> & refGlade);  //constructeur
    ~Gtk_Proprietes();  //destructeur
    int Chargement_Liste_Carte_Son(void);   //Lors du chargement des cartes sons du système
    int Chargement_Accords(std::string fichier_xml);    //Chargement de tous les accords
    void SetParametres(parametres parabm);   //Mise à jour des paramètres actuels
    void SetCheminParam_XML(std::string Chemin);    //Mise à jour de la variable du chemin du fichier des parametres
    void SetCheminShare(std::string Chemin);

    protected:
    virtual void on_cboCarteSon_changed();  //Lors du changement de la carte son
    virtual void on_EchantillonChange();    //Au changement du nombre d'échantillons
    virtual void on_chkFrequence();
    #ifdef _WIN32
    virtual void on_EchantillonnageChange();
    #endif
    virtual void on_Valider();  //Lors du clic sur le bouton valider
    virtual void on_Annuler();  //lors du clic sur le bouton annuler
    virtual void on_cboGraphique_changed(); //lors du changement du choix de l'interface graphique
    private:
    Glib::RefPtr<Gnome::Glade::Xml> m_refGlade; //Pointeur sur le fichier Glade
    Gtk::ComboBox *m_cboAccord, *m_cboCarteSon,*m_cboGraphique; //Pointeur sur les trois combos
    Gtk::SpinButton *m_ctlSpin_Echantillon; // Nbre d'échantillons
    Gtk::SpinButton *m_ctlSpin_FreqEchantillonage;   //Fréquence echantillonnage
    Gtk::Button *m_btnValider;  //Pointeur sur le bouton Valider
    Gtk::Button *m_btnAnnuler;  //Pointeur sur le bouton Annuler
    Gtk::SpinButton *m_ctlSpin_Attenuation;   //Fréquence echantillonnage
    Gtk::CheckButton *m_ctl_CheckFrequence; //Le check pour savoir si on affiche ou pas le fenetre spectrale
    Gtk::CheckButton *m_ctl_CheckRepere;  //Le check pour savoir si on affiche les repères dans la fenetre spectrale
    Gtk::Image *m_imgFenetre;
    ModelColumns m_Columns_accord,m_Columns_carte_son;  //Variable pour les éléments des deux combos
    Glib::RefPtr<Gtk::ListStore> m_refTreeModel_Accord,m_refTreeModel_CarteSon; //Pointeur sur la liste des éléments des combos

    unsigned long int nPowerEchantillons;   //Nb d'échantillons total à  enregistrer
#ifdef _WIN32
    unsigned long int nFrequenceEchantillonnage; //Fréquence d'échantillonnage
#endif
    std::vector<int> arsndCartes;   //Vecteur des index des cartes son
    parametres param_xml;   //Variable sur la structure des parametres
    std::string szChemin_param_xml; //Chemin du fichier des parametres
    std::string szChemin_share; //Chemin du dossier share

    int Chargement_Liste_Carte_Son_Linux(void);//Lors du chargement de la liste des cartes sons pour Linux
    int Chargement_Liste_Carte_Son_W$(void);//Lors du chargement de la liste des cartes sons pour Windaube
};
#endif // PROPRIETES_H_INCLUDED
