#ifndef VARIABLES_H_INCLUDED
#define VARIABLES_H_INCLUDED
#define ALSA_HARDWARE "hw"
#define ALSA_HARDWARE_CARD ALSA_HARDWARE":%d"   //macro pour retrouver la carte de la forme hw:x


// Structure pour les parametres stockes
typedef struct parametres
{
    unsigned int nNumero_carte_son;  //Numero d'indice de la carte son
    unsigned int nFreqEchantillonnage;   //La Frequence d'échantillonage de la carte son
    unsigned int nNbreEchantillon;   //Nombre d'échantillons utlisés pour faire la transformée de Fourier
    unsigned int nNumeroAccord;  //Numéro d'indice de l'accord utilisé
    bool bVisuFreq;  //Boléen sur la visualisation de la fenêtre spectrale
    unsigned int nValeurAttenuation; //Valeur de l'atténuation du signal
    bool bFichierOK;    //Booléen pour savoir si le fichier xml des parametres existe
     int nInterface_Affichage;//Numéro de l'interface (1 : Standard, 2 : Ronde)
     bool bVisuRepere;//Pour la visualisation des notes
}_parametres;
//Structures pour l'affichage des notes (couleur, fréquence trouvée, la note la plus près etc..)
typedef struct _parametres_affichage
{
     bool bcouleur;
     int Index_Note_Inferieure, Index_Note_Superieure, Index_Note_Proche;
     double Note_Inferieure, Note_Superieure, Frequence_Pic,Rapport_precision,Niveau_Max;
     Gdk::Color Couleur;
} parametres_affichage;
class ModelColumns : public Gtk::TreeModel::ColumnRecord    //Classe pour les combos
    {
    public:
        ModelColumns()  //Constructeur
        {
            add(m_col_id);  //Ajout N° de la ligne
            add(m_col_name);    //Ajout Nom de la ligne
        }
        Gtk::TreeModelColumn<int> m_col_id; // N° de la ligne
        Gtk::TreeModelColumn<Glib::ustring> m_col_name; //Nom de la colonne
    };
#endif // VARIABLES_H_INCLUDED
