#include <gtkmm/main.h>
#include "Gtk_Tuner.h"
#include <iostream>
#include <libintl.h>
#define _(String) gettext (String)

#ifdef HAVE_CONFIG_H
  #include "config.h"
#endif

#ifdef _WIN32
#include <direct.h>
#endif



int main(int argc,char *argv[])
{
    Gtk::Main kit(argc,argv); //initialisation du processus Gtk

    Glib::RefPtr<Gnome::Glade::Xml> refXml;    //Variable pour le fichier glade xml

//on retrouve les chemins des fichiers glade et xml

    std::string chemin_glade,chemin_xml;

    setlocale (LC_ALL, "");
    

    #ifdef HAVE_CONFIG_H
    {
        chemin_glade=GLADE_DIR;
        chemin_xml=GLADE_DIR;

        chemin_glade += "/GuitarTuner.glade";
        chemin_xml+= "/accords.xml";

	bindtextdomain (PACKAGE, LOCALEDIR);
	textdomain (PACKAGE);

    }
    #else
    {
        char chemin_courant[PATH_MAX];

        getcwd(chemin_courant,PATH_MAX);
        std::string strChemin(chemin_courant);

        chemin_glade=(strChemin+"/share/GuitarTuner.glade");
        chemin_xml=(strChemin+"/share/accords.xml");

	bindtextdomain("guitartuner","/usr/share/locale");
	textdomain("guitartuner");

    }

    #endif


    #ifdef GLIBMM_EXCEPTIONS_ENABLED    //si Glib est défini
    {
	std::string message(_("Problem to load the glade file"));
        try
        {
	     refXml=Gnome::Glade::Xml::create(chemin_glade,"","guitartuner"); //création de l'objet glade xml

        }
        catch (const Gnome::Glade::XmlError &ex)    //en cas dhpaned1'erreur
        {
            Gtk::MessageDialog Dialog(ex.what(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title(message);
            Dialog.run();   // affichage d'une boite de dialogue relatant le problème
            return 1;
        }

    }
    #else   //si glib n'est pas défini
    {
        std::auto_ptr<Gnome::Glade::XmlError> error;
        refXml = Gnome::Glade::Xml::create(chemin_glade,"","",error);
        if(error.get()) //si problème à la création de l'objet
        {
            Gtk::MessageDialog Dialog(ex.what(),false,Gtk::MESSAGE_ERROR,Gtk::BUTTONS_CLOSE,false );
            Dialog.set_title(message);
            Dialog.run();
            return 1;   //affichage d'une boite de dialogue
        }


    }
    #endif  //GLIBMM_EXCEPTIONS_ENABLED

    Gtk_Tuner *pWindow=0;   //La fenetre Glade

    pWindow=new Gtk_Tuner(refXml);
    if (pWindow)    //Si elle existe
    {
        pWindow->SetPathAccordXML(chemin_xml);  //Mise à jour du chemin du fichier Accord.xml
        pWindow->Chargement_Proprietes();   //Chargement des propriétés
        kit.run(*pWindow);  //Affichage de la fenetre
    }

    delete pWindow;

    return 0;   //fin
}

/*TODO
Traiter les messages d'erreur de Gtkmm
...
 */
